package ru.mobilab.crazysong;

import java.io.IOException;

import android.app.Activity;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnCompletionListener;
import android.media.MediaPlayer.OnPreparedListener;
import android.media.SoundPool;
import android.media.SoundPool.OnLoadCompleteListener;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

public class CrazySongActivity extends Activity implements OnTouchListener {
	private SoundPool soundPool;
	private int soundID;
	private int soundID2;
	boolean loaded = false;
	int num=0;
	
	//   
    private MediaPlayer mediaPlayer;
    boolean mploaded=false;
    
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)  {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        //    Textview
		View view = findViewById(R.id.textView1);
		view.setOnTouchListener(this);   
		//      
		this.setVolumeControlStream(AudioManager.STREAM_MUSIC);
		//   
		Log.e("Test", "Checkpoint1");
		soundPool = new SoundPool(10, AudioManager.STREAM_MUSIC, 0);
		Log.e("Test", "Checkpoint2");
		soundPool.setOnLoadCompleteListener(new OnLoadCompleteListener() {
			@Override
			public void onLoadComplete(SoundPool soundPool, int sampleId, int status) {
				loaded = true;
				Log.e("Test", "sampleId="+sampleId+" status="+status);
			}
		});
		soundID = soundPool.load(this, R.raw.sound1, 1);
		Log.e("Test", "soundID");
		soundID2 = soundPool.load(this, R.raw.sound2, 1);
		Log.e("Test", "soundID2");
		
		//
		
		mediaPlayer = MediaPlayer.create(this, R.raw.mediatest); //   (. )
		
		mediaPlayer.start();
/*
 *   ,     
 * 		
		mediaPlayer = new MediaPlayer();
		mediaPlayer.setOnPreparedListener(new OnPreparedListener(){
			@Override
			public void onPrepared(MediaPlayer arg0) {
				// TODO Auto-generated method stub
				Log.e("Test", "MP   ");
				arg0.start();
			}	
		});


		
		try {
			mediaPlayer.setDataSource("http://www.tamgdesvet.ru/music/TamGdeSvet-Proshay.mp3");
			
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
			catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		mediaPlayer.prepareAsync();
		
*/
		//    
		mediaPlayer.setOnCompletionListener(new OnCompletionListener() {
        	 
            public void onCompletion(MediaPlayer arg0) {
                 arg0.start();   
            }
		});

    }
    
    @Override
	public boolean onTouch(View v, MotionEvent event) {
		if (event.getAction() == MotionEvent.ACTION_DOWN) {
			// Getting the user sound settings
			AudioManager audioManager = (AudioManager) getSystemService(AUDIO_SERVICE);
			float actualVolume = (float) audioManager
					.getStreamVolume(AudioManager.STREAM_MUSIC);
			float maxVolume = (float) audioManager
					.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
			float volume = actualVolume / maxVolume;
			// Is the sound loaded already?
		
			
			if (loaded) {
				num=num+1;
				if (num % 2==0){
					soundPool.play(soundID, volume, volume, 1, 0, 1f);
				} else {
					soundPool.play(soundID2, volume, volume, 1, 0, 1f);
				}
				Log.e("Test", "Played sound - "+num);
			}
		}
		return false;
	}
}